EFL_CLASSIC = select(4, GetBuildInfo()) < 20000
if EFL_CLASSIC then
	OOO = 0;
	STA = 1;
	INT = 2;
	STR = 3;
	AGI = 4;
	SPI = 5;
	MAN = 6;
	HEA = 7;
	DMG = 8;
	EFL_Stat = {
		[OOO] = _G["ALL"],
		[STA] = _G["ITEM_MOD_STAMINA_SHORT"],
		[INT] = _G["ITEM_MOD_INTELLECT_SHORT"],
		[STR] = _G["ITEM_MOD_STRENGTH_SHORT"],
		[AGI] = _G["ITEM_MOD_AGILITY_SHORT"],
		[SPI] = _G["ITEM_MOD_SPIRIT_SHORT"],
		[MAN] = _G["ITEM_MOD_POWER_REGEN0_SHORT"],
		[HEA] = _G["ITEM_MOD_HEALTH_REGENERATION_SHORT"],
		[DMG] = _G["DAMAGE"]
	}
else
	OOO = 0;
	STA = 1;
	INT = 2;
	STR = 3;
	HST = 4;
	AGI = 5;
	CRI = 6;
	MAS = 7;
	DDG = 8;
	PAR = 9;
	VER = 10;
	MAX = 11;
	DMG = 12;
	ATK = 13;
	SPP = 14;
	MAN = 15;
	HEA = 16;
	RUN = 17;
	FSH = 18;

	EFL_Stat = {
		[OOO] = _G["ALL"],
		[STA] = _G["ITEM_MOD_STAMINA_SHORT"],
		[INT] = _G["ITEM_MOD_INTELLECT_SHORT"],
		[STR] = _G["ITEM_MOD_STRENGTH_SHORT"],
		[HST] = _G["ITEM_MOD_HASTE_RATING_SHORT"],
		[AGI] = _G["ITEM_MOD_AGILITY_SHORT"],
		[CRI] = _G["ITEM_MOD_CRIT_RATING_SHORT"],
		[MAS] = _G["ITEM_MOD_MASTERY_RATING_SHORT"],
		[VER] = _G["ITEM_MOD_VERSATILITY"],
		[DDG] = _G["ITEM_MOD_DODGE_RATING_SHORT"],
		[PAR] = _G["ITEM_MOD_PARRY_RATING_SHORT"],
		[SPP] = _G["ITEM_MOD_SPELL_POWER_SHORT"],
		[MAN] = _G["ITEM_MOD_POWER_REGEN0_SHORT"],
		[HEA] = _G["ITEM_MOD_HEALTH_REGENERATION_SHORT"],
		[ATK] = _G["ITEM_MOD_ATTACK_POWER_SHORT"],
		[MAX] = EFL_FoodLocaleText["highest"],
		[DMG] = _G["DAMAGE"],
		[RUN] = _G["ITEM_MOD_CR_SPEED_SHORT"],
		[FSH] = _G["PROFESSIONS_FISHING"]
	}
end

if EFL_CLASSIC then
	EFL_Level = {
		[0] = "Classic"
	}
else
	EFL_Level = {
		[0] = "Classic",
		[1] = "BC",
		[2] = "WotLK",
		[3] = "Cataclysm",
		[4] = "MoP",
		[5] = "WoD",
		[6] = "Legion",
		[7] = "BfA",
		[8] = "Shadowlands"
	}
end

EFL_Op = {
	[0] = "=",
	[1] = ">=",
	[2] = "<="
}


-- STAT DROPDOWN ------------------------------------------------

function EFL_StatDropDown_Init()
	local entries = table.getn(EFL_Stat);
	for i=0,entries do
		local info = {};
		info.text = EFL_Stat[i];
		info.value = i;
		info.func = EFL_StatDropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end
end

function EFL_StatDropDown_OnShow()
	-- Nasty "hack", load Blizzard_Calendar if not loaded,
	-- for it to secure init 24 dropdown menu buttons,
	-- to avoid action blocked by tainting
	if not IsAddOnLoaded("Blizzard_Calendar") then
		LoadAddOn("Blizzard_Calendar")
	end
    UIDropDownMenu_Initialize(EFL_StatDropDown, EFL_StatDropDown_Init);
    UIDropDownMenu_SetSelectedID(EFL_StatDropDown, EFL_Options["SelectedStat"]+1);
    UIDropDownMenu_SetWidth(EFL_StatDropDown, 150);
    EFL_ScrollBar_Update();
end

function EFL_StatDropDown_OnClick(this)
    local i = this:GetID();
    UIDropDownMenu_SetSelectedID(EFL_StatDropDown, i);
    EFL_Options["SelectedStat"] = i-1;
    EFL_ScrollBar_Update();
end


-- LEVEL OP ------------------------------------------------

function EFL_LevelOp_Init()
	local entries = table.getn(EFL_Op);
	for i=0,entries do
		local info = {};
		info.value = i;
		info.text = EFL_Op[i];
		info.func = EFL_LevelOp_OnClick;
		UIDropDownMenu_AddButton(info);
	end
end

function EFL_LevelOp_OnShow()
    UIDropDownMenu_Initialize(EFL_LevelOp, EFL_LevelOp_Init);
    UIDropDownMenu_SetSelectedID(EFL_LevelOp, EFL_Options["SelectedLevelOp"]+1);
    UIDropDownMenu_SetWidth(EFL_LevelOp, 40);
    EFL_ScrollBar_Update();
end

function EFL_LevelOp_OnClick(this)
    local i = this:GetID();
    UIDropDownMenu_SetSelectedID(EFL_LevelOp, i);
    EFL_Options["SelectedLevelOp"] = i-1;
    EFL_ScrollBar_Update();
end

-- ITEMLEVEL DROPDOWN ------------------------------------------------

function EFL_LevelDropDown_Init()
	local entries = table.getn(EFL_Level);
	for i=0,entries do
		local info = {};
		info.text = EFL_Level[i];
		info.value = i;
		info.func = EFL_LevelDropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end
end

function EFL_LevelDropDown_OnShow()
    UIDropDownMenu_Initialize(EFL_LevelDropDown, EFL_LevelDropDown_Init);
    UIDropDownMenu_SetSelectedID(EFL_LevelDropDown, EFL_Options["SelectedLevel"]+1);
    UIDropDownMenu_SetWidth(EFL_LevelDropDown, 80);
    EFL_ScrollBar_Update();
end

function EFL_LevelDropDown_OnClick(this)
    local i = this:GetID();
    UIDropDownMenu_SetSelectedID(EFL_LevelDropDown, i);
    EFL_Options["SelectedLevel"] = i-1;
    EFL_ScrollBar_Update();
end

